// vim: foldmethod=marker

//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005-2006
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//


// copies goDoCommand but passes all extra arguments
flock.command = function (aCmd) {/*{{{*/
    var args = flock.lang.toArray(arguments);
    args.shift();
    XXX('flock.command', args);
    var _this = this;
    try {
        var controller = top.document.commandDispatcher
            .getControllerForCommand(aCmd);
        if (controller && controller.isCommandEnabled(aCmd)) {
            flock.command.context = args;
            controller.doCommand(aCmd);
            flock.command.context = null;
            // XXX andy: the world may not be ready for this feature
            //else {
            //    flock.require('flock.common.xpcom');
            //    var enum = new flock.xpcom.JsSimpleEnumerator(args);
            //    controller.doCommandWithParams.call(_this, aCmd, enum);
            //}
        }
    }
    catch (e) {
        XXX("Error while executing command", aCmd);
        dd(e);
    }
}/*}}}*/

flock.command.context = null;


flock.command.Controller = function (aNode, aOpts) {/*{{{*/
    flock.xul.Node.apply(this, aNode, aOpts);
}/*}}}*/
dojo.inherits(flock.command.Controller, flock.xul.Node);
dojo.lang.extend(flock.command.Controller, {
    // nsIController
    doCommand: function (aCmd) {/*{{{*/
        
    },/*}}}*/
    isCommandEnabled: function (aCmd) {/*{{{*/
        
    },/*}}}*/
    onEvent: function (aEvt) {},
    supportsCommand: function (aCmd) {/*{{{*/

    },/*}}}*/
    
    // cool stuff
    
});


/*{{{*/
        // laying in bed instead of going out
        // getting on a train instead of a plane
        // i feel real
/*}}}*/


var CommandController = function (aOpts) {/*{{{*/
    if (!aOpts) aOpts = {};
    dojo.lang.mixin(this, aOpts);
    if (this.debug && this.debugFromCommandset) {
        if (this.debugCommands == null) this.debugCommands = [];
        var commandset = $(aOpts['debugFromCommandset']);
        for (var i = 0; i < commandset.childNodes.length; ++i) {
            this.debugCommands.push(commandset.childNodes[i].id);
        }
        XXX(this.debugCommands);
    }
};/*}}}*/
//CommandController.prototype = {
dojo.lang.extend(CommandController, {
    isDebug: false,
    debugCommands: null,
    getFunctor: function(aCmd) {/*{{{*/
        if (aCmd in this) return this[aCmd];
        return;
    },/*}}}*/
    supportsCommand: function(aCmd) {/*{{{*/
        if (this.isDebug) {
            var r = (this.debugCommands.indexOf(aCmd) != -1 || this[aCmd] != null);
            return r;
        }
        return (this[aCmd] != null);
    },/*}}}*/
    isCommandEnabled: function(aCmd) {/*{{{*/
        if (this.isDebug) {
            if (this[aCmd]) {
                if ("isEnabled" in this[aCmd]) r = this[aCmd].isEnabled();
                else r = true;
            }
            else r = (this.debugCommands.indexOf(aCmd) != -1);
            XXX('isEnabled', aCmd, r);
            return r;
        }
        var f = this[aCmd];
        if (typeof this[aCmd] == "object" && "isEnabled" in this[aCmd]) return this[aCmd].isEnabled();
        return true;
    },/*}}}*/
    doCommand: function(aCmd) {/*{{{*/
        if (this[aCmd]) {
            if (typeof this[aCmd] == "object" 
                && "exec" in this[aCmd]) 
                return this[aCmd].exec.apply(this, flock.command.context);
            return this[aCmd].apply(this, flock.command.context);
        }
        return;
    },/*}}}*/
    doCommandWithParams: function(aCmd, aEnum) {/*{{{*/
        var params = flock.lang.toArray(aEnum);
        if (this[aCmd]) {
            if (typeof this[aCmd] == "object" 
                && "exec" in this[aCmd]) 
                return this[aCmd].exec.apply(this, params);
            return this[aCmd].apply(this, params);
        }
        return;
    },/*}}}*/
    onEvent: function(aEvent) { }
});

var Functor = function (aOpts) {/*{{{*/
    if (!aOpts) aOpts = {};
    dojo.lang.mixin(this, aOpts);
};/*}}}*/
Functor.prototype = {/*{{{*/
    isEnabled: function () { return true; },
    exec: function () { }
}/*}}}*/
/*
    Example Usage:

    function flock_initBookmarkView() {
        var tree = $('flock_bookmarkView');
        
        var treeController = new CommandController();
        
        var cmd_delete = new Functor();
        cmd_delete.isEnabled = function () {
            return (tree.view.selection.count);
        };
        cmd_delete.exec = function () {
            curIndex = tree.view.selection.currentIndex;
            dd(flock_treeGetRow(tree, curIndex));
            alert("you tried to delete something!" + curIndex);
        };
        
        treeController.cmd_delete = cmd_delete;

       tree.controllers.appendController(treeController);
    }
*/

function flock_updateCommandset(aSet, aClimb) {/*{{{*/
    //aClimb = true;
    XXX('flock_updateCommandset', aSet.id);
    for (var i = 0; i < aSet.childNodes.length; ++i) {
        var command = aSet.childNodes[i];
        goUpdateCommand(command.id);
        //XXX('updating command', command.id);
        
        //var focused = document.commandDispatcher.focusedElement;
        //if (!focused) focused = window;
        
        //var supportsTest = function (aTest) {
        //    if (aTest.controllers
        //        && aTest.controllers.commandDispatcher) {
        //        var c = aTest.controllers.getControllerForCommand(command.id);
        //        XXX('controllers available');
        //        if (c) return true;
        //        XXX('no controller found for cmd');
        //        return false;
        //    }
        //    XXX('no controllers available');
        //    return false;
        //}
        
        //if (aClimb) {
        //    focused = flock_climbTo(focused, supportsTest);
        //    if (!focused) continue;
        //}
        //if (!supportsTest(focused)) continue;
        //var controller = focused.controllers.getControllerForCommand(command.id);
        //XXX('no controller found for command', command.id);
        //if (!controller) continue;
        //var enabled = controller.isCommandEnabled(command.id);
        //flock_updateCommandStatus(command, enabled);
    }
}/*}}}*/
function flock_updateCommandStatus(aCommand, aEnabled) {/*{{{*/
    if (aEnabled) {
        XXX('COMMAND',aCommand.id,'enabled');
        aCommand.removeAttribute("disabled");
    } 
    else {
        XXX('COMMAND',aCommand.id,'disabled');
        aCommand.setAttribute("disabled", true);
    }
}/*}}}*/
function flock_goUpdateCommandSet(aSet)/*{{{*/
{
    XXX('UPDATING COMMANDSET', aSet.id);
    for(var i = 0;i < aSet.childNodes.length; ++i) {
        var command = aSet.childNodes.item(i);
        goUpdateCommand(command.id);
        // we are going to go from focus up to the top looking for a
        // controller that supports the given command
        //var supportsTest = function (aTest) {
        //    if (aTest.controllers && aTest.
        //}
        
        //var focused = top.document.commandDispatcher.focusedElement;
        //if (!focused) return;
        
        
        
        
        //var controller = focused.controllers.commandDispatcher.getControllerForCommand(command.id);


        
        ////XXX('CONTROLLER COUNT',top.document.commandDispatcher.getControllers().getControllerCount());
        ////dump("flock_goUpdateCommandSet(aSet) " + command.id + "<>" + controller + "\n");
        //if(!controller) continue;
        //var enabled = controller.isCommandEnabled(command.id);
        //flock_goUpdateCommand(command, enabled);
    }
}/*}}}*/
function flock_goUpdateCommand(aCommand, aEnabled) {/*{{{*/
    if (aEnabled) {
        XXX('COMMAND',aCommand.id,'enabled');
        aCommand.removeAttribute("disabled");
    } 
    else {
        XXX('COMMAND',aCommand.id,'disabled');
        aCommand.setAttribute("disabled", true);
    }

}/*}}}*/
function flock_goDoCommand(command)/*{{{*/
{
    try {
        var controller = top.document.commandDispatcher.getControllerForCommand(command);
        if ( controller && controller.isCommandEnabled(command))
        controller.doCommand(command);
    }
    catch (e) {
        dump("An error occurred executing the " + command + " command\n" + e + "\n");
    }
}/*}}}*/
