/*  *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code Shadows.com API client implementation.
 *
 * The Initial Developer of the Original Code is
 * Pluck Corporation. This code is Copyright (C) 2005, 2006
 * All Rights Reserved.
 *
 * Contributor(s):
 *   Carl Brown (carlb@shadows.com)
 *   Duane Fields (dfields@pluck.com)
 *
 * ***** END LICENSE BLOCK ***** */

shadows.createuser = function (aUsername, aEmailAddress, aPassword, iYearOfBirth, fnCallBack) {

    debug('createUser: called with \n');
    debug('createUser: aUsername "' + aUsername + '"\n');
    debug('createUser: aEmailAddress "' + aEmailAddress + '"\n');
    debug('createUser: aPassword "' + aPassword + '"\n');
    debug('createUser: iYearOfBirth "' + iYearOfBirth + '"\n');
    this.mCreateUserRPC = new flockXmlRpcServer (shadows.XmlRpc.Url("create user"));
    
    var args = [{UserName: aUsername, Password: aPassword, EmailAddress: aEmailAddress, YearOfBirth: iYearOfBirth}];
        
    debug('createUser: args "' + args + '"\n');

        var listener = new Object ();
    listener.onResult = function (aResult) {
        debug('createUser: result \n');
        dd (aResult);
        debug('createUser: returning "' + aResult + '"\n');
        if(typeof fnCallBack=="function") {
            fnCallBack(aResult);
        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onResult=="function")) {
            fnCallBack.onResult(aResult);
        }
    }
    listener.onFault = function (aFaultCode, aFaultString) {
        PluckDebug.fail('createUser: fault code=' + aFaultCode + '\n');
        PluckDebug.fail('                     string="' +  aFaultString + '\n');
        if(typeof fnCallBack=="function") {
            fnCallBack(false, 'fault code=' + aFaultCode + 'string="' +  aFaultString + '\n');
        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onFault=="function")) {
            fnCallBack.onFault(aFaultCode, aFaultString);
        }
    }
    listener.onError = function (aMessage) {
        PluckDebug.fail('createUser: error "'+aMessage+'"\n');
        if(typeof fnCallBack=="function") {
            fnCallBack(false, 'error "'+aMessage+'"\n');
        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onError=="function")) {
            fnCallBack.onError(aMessage);
        }
    }
    this.mCreateUserRPC.call ('shadows.user.create', args, listener);
    
    return true;
}

