var feedUtils = {};

feedUtils.loadFeedFromLocalOPML = function (aURL) {
    var IO_SERVICE_CONTRACTID         = '@mozilla.org/network/io-service;1';
    var nsIIOService                  = Components.interfaces.nsIIOService;
    var OPML_SERVICE_CONTRACTID       = "@flock.com/opml-service;1";
    var flockIOpmlService             = Components.interfaces.flockIOpmlService;

    var ios = Components.classes[IO_SERVICE_CONTRACTID]
            .getService(nsIIOService);
    var channel = ios.newChannel(aURL, null, null);

    var loader = Components.classes["@mozilla.org/content/syncload-dom-service;1"]
        .getService(Components.interfaces.nsISyncLoadDOMService);
    var opmldoc = loader.loadLocalDocument(channel, null);
    var opmlsrv = Components.classes[OPML_SERVICE_CONTRACTID]
        .getService(flockIOpmlService);
    opmlsrv.subscribeDOM(aURL, opmldoc, null);
}

feedUtils.getURLFromFile = function(aFile) {
    var ios = Components.classes["@mozilla.org/network/io-service;1"]
        .getService(Components.interfaces.nsIIOService);
    var fileHandler = ios.getProtocolHandler("file")
        .QueryInterface(Components.interfaces.nsIFileProtocolHandler);
    return fileHandler.getURLSpecFromFile(aFile);
}

feedUtils.isValidURL = function(aURL) {
    var uri = Components.classes["@mozilla.org/network/standard-url;1"]
        .createInstance(Components.interfaces.nsIURI);
    try {
        uri.spec = aURL
        if(uri.scheme == "http" || uri.scheme == "https" || uri.scheme == "file")
        	return true;
       	return false;
    } catch(e) {
        return false;
    }
}
