var spreadFlockDlg = {};
const PREF_SPREAD_FLOCK = 'flock.photo.spreadFlock.include';
const PREF_TAGLINE = 'flock.photo.tagline';

spreadFlockDlg.mPrefSvc = null;

spreadFlockDlg.load = function() {
    this.mPrefSvc = Components.classes["@mozilla.org/preferences-service;1"]
                               .getService(Components.interfaces.nsIPrefBranch);
    this.mPrefObserverSvc = this.mPrefSvc.QueryInterface (Components.interfaces.nsIPrefBranchInternal);

    // change the buttons
    var dlg = document.getElementById('spreadFlock');

    // FIXME - on mac cancel should be the element that if you press return is selected in this dialog
    dlg.getButton('cancel').focus();
    this.setupImage();

    this.mPrefObserverSvc.addObserver (PREF_TAGLINE, this, false);
}

spreadFlockDlg.setupImage = function () {
    document.getElementById('flock-props-image').setAttribute ('src', 'http://spread.flock.com/taglines/images/' +
    this.mPrefSvc.getCharPref (PREF_TAGLINE));
}

spreadFlockDlg.accept = function() {
    openFlockPreferences('panePhotos');
}

spreadFlockDlg.cancel = function() {
    this.mPrefSvc.setCharPref(PREF_SPREAD_FLOCK, "never");
}

spreadFlockDlg.unload = function() {
    this.mPrefObserverSvc.removeObserver (PREF_TAGLINE, this);
}

spreadFlockDlg.changeTagLine = function () {
    window.openDialog ("chrome://browser/content/flock/photo/taglineChooser.xul", "_blank", "modal,close,centerscreen");
}

spreadFlockDlg.observe = function (subject, topic, prefName) {
    if (topic == 'nsPref:changed' && prefName == PREF_TAGLINE) {
        this.setupImage ();
    }
}
